$(document).ready(function () {
    $("body").on("blur", ".barcode", itemModalShow);
    $(".iTbody").on("click", ".itemTr", addTrVal);
    $(".itemModal").on("keyup", ".isearch", getItemData);
    $(".itemModal").on("change", ".isortBy, iorderAS", getItemData);
    $(".inoRecord").hide();

    window.addEventListener('keydown', function (e) {
        if (e.keyIdentifier == 'U+000A' || e.keyIdentifier == 'Enter' || e.keyCode == 13) {
            if (e.target.nodeName == 'INPUT' && e.target.type == 'text' && e.target.className == "iname") {
                addTrVal(e);
            }
        }
    }, true);

    function itemModalShow() {
        var tr = $(this).closest("tr"),
                srno = tr.find(".srno").val(),
                party = $(".cmbparty").val(),
                file = $(".file").val(),
                margin = srno * 2.5,
                barcode = tr.find(".barcode").val(),
                itemcode = tr.find(".itemcode").val();
        var vouchdt = $(".vouchdt").val();

        $(".modal-content").css("margin-top", margin + "%")

        if (barcode == "") {
            $(".itemname").removeClass("dataItemname");
            $(".barcode").removeClass("dataBarcode");
            $(".itemcode").removeClass("dataItemcode");
            $(".type").removeClass("dataType");
            $(".origin").removeClass("dataOrigin");
            $(".qty").removeClass("dataQty");
            $(".batch").removeClass("dataBatch");
            $(".bbfmon").removeClass("dataBbfmon");
            $(".bbfyear").removeClass("dataBbfyear");

            tr.find(".itemname").addClass("dataItemname");
            tr.find(".barcode").addClass("dataBarcode");
            tr.find(".itemcode").addClass("dataItemcode");
            tr.find(".unit").addClass("dataUnit");
            tr.find(".type").addClass("dataType");
            tr.find(".qty").addClass("dataQty");
            tr.find(".origin").addClass("dataOrigin");
            tr.find(".batch").addClass("dataBatch");
            tr.find(".unit").addClass("dataUnit");
            tr.find(".bbfmon").addClass("dataBbfmon");
            tr.find(".bbfyear").addClass("dataBbfyear");
            $(".itemModal").modal("show");
            getItemData();
        } else {
            $.ajax({
                type: "POST",
                datatype: "json",
                url: "search_onl_ibarcode.php",
                data: {barcode: barcode, itemcode: itemcode, party: party, file: file, vouchdt: vouchdt,paras:"S"},
                success: function (response) {
                    var m = response;

                    tr.find(".itemcode").val(m.itemcode).trigger("change");
                    tr.find(".batch").val(m.batch);
                    tr.find(".origin").val(m.origin);
                    tr.find(".bbfmon").val(m.bbfmon);
                    tr.find(".bbfyear").val(m.bbfyear);
                    tr.find(".unit").val(m.unit);
                    tr.find(".qty").focus();
                    tr.find(".qty").select();

                },
                error: function (request, textStatus, errorThrown) {

                }
            });
        }
    }

    $(".itemModal").on('shown.bs.modal', function () {
        $(".isearch").focus();
        $(".isearch").val("");
        $(".ifield").val("1");
        getItemData();
    });

    $(".itemModal").on('hidden.bs.modal', function () {
        $(".dataQty").focus();
//        $(".qty").focus();$(".dataCartQty").focus();
        $(".dataQty").select();
    });

    var imrangeFrom = 0,
            imrangeTo = 40;

    function getItemData(pagination) {

        $(".iloader").show();

        if (pagination == 'prev') {
            if (imrangeFrom > 0) {
                imrangeFrom = (imrangeFrom - 40);
                imrangeTo = (imrangeTo - 40);
            }
        }
        if (pagination == 'next') {
            imrangeFrom = (imrangeFrom + 40);
            imrangeTo = (imrangeTo + 40);
        }

        var vouchno = $(".vouchno").val(),
                file = $(".file").val(),
                isearch = $(".isearch").val(),
                ifield = $(".ifield").val(),
                ioperator = $(".ioperator").val(),
                sortBy = $(".isortBy").val(),
                orderAs = $(".iorderBy").val(),
                vouchdt = $(".vouchdt").val(),
                party = $(".cmbparty").val(),
                data = {isearch: isearch, ifield: ifield, ioperator: ioperator, sortBy: sortBy, orderAs: orderAs, vouchdt: vouchdt,
                    vouchno: vouchno, file: file, rangeFrom: imrangeFrom, rangeTo: imrangeTo, party: party},
                values = "";
        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "search_onl_item.php",
            data: data,
            success: function (response) {
                $.each(response, function () {
                    values += "<tr class='itemTr'>" +
//                            "<td align='left'><input type='text' class='itemcode' value='" + this.itemcode + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='ibarcode' value='" + this.barcode + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='iname' value='" + this.name + "' readonly style='width:100%'>" +
                            "<td align='left'><input type='text' class='itype' value='" + this.type + "' readonly style='width:100%'>" +
                            "<td align='left'><input type='text' class='iorigin' value='" + this.origin + "' readonly style='width:100%'>" +
                            "<td align='left'><input type='text' class='ibatch' value='" + this.batch + "' readonly style='width:100%'>" +
                            "<td align='left'><input type='text' class='ibbf' value='" + this.bbf + "' readonly style='width:100%'>" +
                            "<input type='hidden' class='iitemcode' value='" + this.itemcode + "' readonly></td>" +
                            "<input type='hidden' class='ibatch' value='" + this.batch + "' readonly></td>" +
                            "<input type='hidden' class='itype' value='" + this.type + "' readonly></td>" +
                            "<input type='hidden' class='ibbfmon' value='" + this.bbfmon + "' readonly></td>" +
                            "<input type='hidden' class='ibbfyear' value='" + this.bbfyear + "' readonly></td>" +
                            "</tr>";
                });
                $(".iloader").hide();
                $(".iTbody").empty();
                $(".iTbody").html(values);
                if (response) {
                    $(".search-action-bar").show();
                }
            },
            error: function (request, textStatus, errorThrown) {

            }
        });
    }
    $(".iload").click(function () {
        getItemData();
    });
//    $(".isearch").change(function () {
//        getItemData();
//    });
    $(".iprevious").click(function () {
        getItemData('prev');
    });
    $(".inext").click(function () {
        getItemData('next');
    });

    function addTrVal(e) {
        var tr = "";
        if (e == "undefined") {
            tr = $(this).closest("tr");
        } else {
            tr = $(e.target).closest("tr");
        }

        var iname = tr.find(".iname").val(),
                ibarcode = tr.find(".ibarcode").val(),
                iitemcode = tr.find(".iitemcode").val(),
                itype = tr.find(".itype").val(),
                iunit = tr.find(".iunit").val(),
                ibatch = tr.find(".ibatch").val(),
                ibbfmon = tr.find(".ibbfmon").val(),
                ibbfyear = tr.find(".ibbfyear").val(),
                iorigin = tr.find(".iorigin").val();



        $(".dataItemname").val(iname);
        $(".dataBarcode").val(ibarcode);
        $(".dataItemcode").val(iitemcode).trigger("change");
        $(".dataBatch").val(ibatch);
        $(".dataUnit").val(iunit);
        $(".dataBbfmon").val(ibbfmon);
        $(".dataBbfyear").val(ibbfyear);
        $(".dataOrigin").val(iorigin);
        $(".dataType").val(itype);


        $(".dataItemname").removeClass('dataItemname');
        $(".dataItemcode").removeClass('dataItemcode');
        $(".dataBarcode").removeClass('dataBarcode');
        $(".dataItem").removeClass('dataItem');
        $(".dataBatch").removeClass("dataBatch");
        $(".dataUnit").removeClass("dataUnit");
        $(".dataBbfmon").removeClass("dataBbfmon");
        $(".dataBbfyear").removeClass("dataBbfyear");
        $(".dataOrigin").removeClass("dataOrigin");
        $(".dataType").removeClass("dataType");
        $(".itemModal").modal("hide");
        $(".dataQty").focus();

    }


    $(".qty").blur(function () {
        $(".dataQty").removeClass("dataQty");
    });
});